Subject: [bug#31934] [PATCH] Fix ALSA_PLUGIN_DIR usage

From: [email-masked] (Ludovic Courtès)
Date: Sat, 23 Jun 2018 23:54:22 +0200

Julien Lepiller <[email-masked]> skribis:

> Le Fri, 22 Jun 2018 21:54:45 +0200,
> [email-masked] (Ludovic Courtès) a écrit :
>
>> Could you clarify which issue this fixes?
>> 
>> Also, I think you really want ‘native-search-paths’ and not
>> ‘search-paths’.  The latter is meant to be used by things like
>> cross-compilers.
>> 
>> Thanks,
>> Ludo’.
>
> The issue was that a part of the code was only partially patched. It
> looked like:
>
> plugdir = ALSA_PLUGIN_DIR;
> envplugdir = getenv("ALSA_PLUGIN_DIR");
> if(envplugdir != NULL)
>   plugdir = envplugdir;
> ...
> sofile = malloc(sizeof(plugdir) + ...);
> ...
> sprintf(sofile, "%s/whatever.so", ALSA_PLUGIN_DIR);
>
> If at compilation time ALSA_PLUGIN_DIR is bigger than the runtime
> $ALSA_PLUGIN_DIR, we are in trouble: alsa-lib will crash because of a
> buffer overflow. Otherwise, it just didn't care about $ALSA_PLUGIN_DIR.

Alright, so the patch update can definitely go in!

> The native-search-paths vs search-paths is a bit confusing... I need to
> read the manual more carefully I guess.

The manual doesn’t say much about this, so you have a good excuse.

But anyway, that change is surely not necessary.

Thanks,
Ludo’.